package cc.fascinated.bat.features.base;

import cc.fascinated.bat.features.Feature;
import cc.fascinated.bat.features.FeatureProfile;
import cc.fascinated.bat.features.base.commands.botadmin.premium.PremiumAdminCommand;
import cc.fascinated.bat.features.base.commands.fun.EightBallCommand;
import cc.fascinated.bat.features.base.commands.fun.image.ImageCommand;
import cc.fascinated.bat.features.base.commands.general.*;
import cc.fascinated.bat.features.base.commands.general.avatar.AvatarCommand;
import cc.fascinated.bat.features.base.commands.general.banner.BannerCommand;
import cc.fascinated.bat.features.base.commands.server.MemberCountCommand;
import cc.fascinated.bat.features.base.commands.server.PremiumCommand;
import cc.fascinated.bat.features.base.commands.server.channel.ChannelCommand;
import cc.fascinated.bat.features.base.commands.server.feature.FeatureCommand;
import cc.fascinated.bat.service.CommandService;
import lombok.NonNull;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
public class BaseFeature extends Feature {
    @Autowired
    public BaseFeature(@NonNull ApplicationContext context, @NonNull CommandService commandService) {
        super("Base", FeatureProfile.FeatureState.DISABLED, false);

        super.registerCommand(commandService, context.getBean(PremiumCommand.class));
        super.registerCommand(commandService, context.getBean(PremiumAdminCommand.class));
        super.registerCommand(commandService, context.getBean(MemberCountCommand.class));
        super.registerCommand(commandService, context.getBean(ChannelCommand.class));
        super.registerCommand(commandService, context.getBean(VoteCommand.class));
        super.registerCommand(commandService, context.getBean(PingCommand.class));
        super.registerCommand(commandService, context.getBean(InviteCommand.class));
        super.registerCommand(commandService, context.getBean(HelpCommand.class));
        super.registerCommand(commandService, context.getBean(BotStatsCommand.class));
        super.registerCommand(commandService, context.getBean(BannerCommand.class));
        super.registerCommand(commandService, context.getBean(AvatarCommand.class));
        super.registerCommand(commandService, context.getBean(ImageCommand.class));
        super.registerCommand(commandService, context.getBean(FeatureCommand.class));
        super.registerCommand(commandService, context.getBean(EightBallCommand.class));
        super.registerCommand(commandService, context.getBean(LookupUserCommand.class));
    }
}
