package cc.fascinated.bat.features.base.commands.server.feature;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.command.Category;
import cc.fascinated.bat.command.CommandInfo;
import lombok.NonNull;
import net.dv8tion.jda.api.Permission;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
@CommandInfo(name = "feature", description = "Configure features in your guild", requiredPermissions = Permission.ADMINISTRATOR, category = Category.SERVER)
public class FeatureCommand extends BatCommand {
    @Autowired
    public FeatureCommand(@NonNull ApplicationContext context) {
        super.addSubCommands(
                context.getBean(EnableSubCommand.class),
                context.getBean(DisableSubCommand.class),
                context.getBean(ListSubCommand.class)
        );
    }
}
